chiark / gitweb /
setup, bin/: Some scripts which are useful in Cygwin.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   bash_profile bash_logout bashrc inputrc bash_completion
135   emacs emacs-calc vm gnus.el ercrc.el
136   vimrc mg zile lesskey
137   ditz-config
138   mailrc signature muttrc
139   cgrc tigrc
140   gdbinit
141   guile
142   rcrc
143   toprc
144   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
145   pulse-daemon.conf:.pulse/daemon.conf
146   aspell.conf
147   tclshrc:.tclshrc tclshrc:.wishrc
148   lisp-init.lisp:.cmucl-init.lisp
149     lisp-init.lisp:.sbclrc
150     lisp-init.lisp:.clisprc.lisp
151     lisp-init.lisp:.eclrc
152   swank.lisp
153   w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
154   dircolors colordiffrc screenrc cvsrc indent.pro"
155 [ "$xstuff" ] && dotfiles="$dotfiles
156   xinitrc xsession xmodmap Xdefaults vncrc vncsession
157   fonts.conf
158   stalonetrayrc
159   putty-defaults:.putty/sessions/Default%20Settings
160   mdw.session:.config/gnome-session/sessions/mdw.session
161   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
162   e-keybindings.cfg:.enlightenment/keybindings.cfg
163   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
164   e16-bindings:.e16/bindings.cfg"
165 echo "Installing dotfiles..."
166 for d in $dotfiles; do
167   target=.$d
168   case $d in
169     *:*) target=${d#*:} d=${d%%:*};;
170   esac
171   ft=$HOME$sub/$target
172   dir=${ft%/*}
173   mkdir -p $dir
174   ln -s $here/dot/$d $ft.new
175   mv $ft.new $ft
176   echo "  $target"
177 done
178 echo "  all done."
179
180 ## Substitute things which need substituting.
181 dotfilessubst="
182   gitconfig
183   mykermrc
184   pulse-default.pa.in:.pulse/default.pa"
185 echo "Installing dotfiles with substitutions..."
186 for d in $dotfilessubst; do
187   case $d in
188     *:*) target=${d#*:} d=${d%%:*};;
189     *) target=.$d d=$d.in;;
190   esac
191   ft=$HOME$sub/$target
192   dir=${ft%/*}
193   mkdir -p $dir
194   sed "
195 1i\\
196 ### generated by $here/setup; do not edit!\\
197
198 /@home@/ s\a\a$HOME\ag
199 /@profile@/ s\a\a$here\ag
200 /@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
201 " dot/$d >$ft.new
202   mv $ft.new $ft
203   echo "  $target"
204 done
205 echo "  all done."
206
207 ## Symlink backgrounds.
208 backgrounds="
209   bsg-supper.jpg
210   harley-quinn.jpg
211   hypatia.jpg
212   jue-peek.jpg
213   lilith.jpg
214   lovelace.jpg
215   medusa.jpg
216   noodly.jpg
217   rayne.jpg
218 "
219 if [ "$xstuff" ]; then
220   echo "Installing backgrounds..."
221   for b in $backgrounds; do
222     for e in enlightenment e16; do
223       dir=$HOME$sub/.$e/backgrounds
224       t=$dir/$b
225       mkdir -p $dir
226       ln -s $here/bg/$b $t.new
227       mv $t.new $t
228     done
229     echo "  $b"
230   done
231   echo "        all done."
232 fi
233
234 ###--------------------------------------------------------------------------
235 ### Install useful scripts included in this package.
236
237 scripts="
238   mdw-editor
239   mdw-pager
240   mdw-conf
241   mdw-build
242   emacsclient-hack
243   movemail-hack
244   sendmail-hack
245   aspell-hack
246   emerge-hack
247   lesspipe.sh
248   run-with-shell-env
249   start-ssh-agent
250   start-ssh-pageant
251   svnwrap
252   guest-console
253   hyperspec"
254 [ "$xstuff" ] && scripts="$scripts
255   xinitcmd
256   un-backslashify-selection
257   lock-screen
258   xshutdown"
259 echo "Installing scripts..."
260 mkdir -p $HOME$sub/bin
261 for s in $scripts; do
262   ft=$HOME$sub/bin/$s
263   ln -s $here/bin/$s $ft.new
264   mv $ft.new $ft
265   echo "  $s"
266 done
267 echo "  all done."
268
269 hacks="
270   ssh:ssh"
271 echo "Installing hacks..."
272 for h in $hacks; do
273   d=${h%%:*} h=${h#*:}
274   ft=$HOME$sub/bin/hacks/$d
275   mkdir -p $ft
276   ln -s $here/hacks/$h $ft/$h.new
277   mv $ft/$h.new $ft/$h
278   echo "  $d:$h"
279 done
280 echo "  all done."
281
282 ###--------------------------------------------------------------------------
283 ### Set up the Emacs config.
284
285 $echon "Finding a suitable emacs:$echoc"
286 emacs=no
287 for i in emacs22 emacs23 emacs21 emacs; do
288   if type -p >/dev/null $i; then
289     emacs=$i
290     break
291   fi
292 done
293 if [ $emacs = no ]; then
294   echo " failed."
295   emacs=:
296 else
297   echo " $emacs."
298 fi
299
300 echo "Installing Emacs packages..."
301 emacspkg="
302   make-regexp
303   ew-hols
304   mdw-gnus-patch
305   git git-blame vc-git stgit
306   mdw-multiple-cursors
307   quilt"
308 for elib in $emacspkg; do
309   $echon "  $elib:$echoc"
310   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
311        (progn
312          (setq load-path (nconc load-path (list "~/lib/emacs")))
313          (kill-emacs (condition-case nil
314                          (progn (load-library "'"$elib"'") 0)
315                        (error 1))))'; then
316     echo " already installed."
317   else
318     if [ -f el/$elib.el ]; then
319       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
320     else
321       $echon " downloading$echoc"
322       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
323     fi
324     $echon " compiling$echoc"
325     (cd $HOME$sub/lib/emacs;
326       $emacs >/dev/null 2>&1 --no-site-file --batch \
327         --eval '(byte-compile-file "'"$elib.el"'")')
328     echo " done."
329   fi
330 done
331 echo "  all done."
332
333 $echon "Setting up Emacs configuration:$echoc"
334 $echon " linking$echoc"
335 for f in dot-emacs.el Makefile; do
336   set -- $(echo $link | tr : ' ')
337   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
338   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
339 done
340 $echon " compiling$echoc"
341 { cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
342 echo " done."
343
344 ###----- That's all, folks --------------------------------------------------